#include <stdio.h>

int main()
{
    long long int n, q, keks=0, dani=0, pojedeno=0, h;
    scanf("%d%d", &n, &q);
    int i, j;
    long long int d[n];
    long long int p[n];
    long long int k[q];
    for(i=0;i<n;i++)
    {
        scanf("%d", &d[i]);
        scanf("%d", &p[i]);
    }
    for(j=0;j<q;j++)
    {
        scanf("%d", &k[j]);
    }
    for(j=0;j<q;j++)
    {
        for(i=0;i<n;i++)
        {
            while(dani<=k[j]&&dani<d[i])
            {
                if(keks>0)
                {
                    keks--;
                    pojedeno++;
                }
                dani++;
            }
            if(d[i]<=k[j])
            {
                keks=keks+p[i];
                dani=d[i];
            }
        }
        while(dani<=k[j])
        {
            if(keks>0)
            {
                keks--;
                pojedeno++;
            }
            dani++;
        }
        printf("%d\n", pojedeno);
        pojedeno=0;
    }
    return 0;
}